## mingw-w64-gammaray-3.3.0-1.src.tar.zst

=== client/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2013 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

set(gammaray_clientlib_srcs
    classesiconsrepositoryclient.cpp
    classesiconsrepositoryclient.h
    client.cpp
    client.h
    clientconnectionmanager.cpp
    clientconnectionmanager.h
    clientdevice.cpp
    clientdevice.h
    enumrepositoryclient.cpp
    enumrepositoryclient.h
    favoriteobjectclient.cpp
    favoriteobjectclient.h
    localclientdevice.cpp
    localclientdevice.h
    messagestatisticsmodel.cpp
    messagestatisticsmodel.h
    paintanalyzerclient.cpp
    paintanalyzerclient.h
    probecontrollerclient.cpp
    probecontrollerclient.h
    processtracker.cpp
    processtracker.h
    propertycontrollerclient.cpp
    propertycontrollerclient.h
    remotemodel.cpp
    remotemodel.h
    remoteviewclient.cpp
    remoteviewclient.h
    selectionmodelclient.cpp
    selectionmodelclient.h
    tcpclientdevice.cpp
    tcpclientdevice.h
    toolmanagerclient.cpp
    toolmanagerclient.h
    ${CMAKE_SOURCE_DIR}/resources/gammaray.qrc
)

if(APPLE)
    list(APPEND gammaray_clientlib_srcs processtracker_macos.cpp)
elseif(UNIX)
    list(APPEND gammaray_clientlib_srcs processtracker_linux.cpp)
elseif(WIN32)
    list(APPEND gammaray_clientlib_srcs processtracker_windows.cpp)
endif()

add_library(
    gammaray_client SHARED
    ${gammaray_clientlib_srcs}
)
generate_export_header(gammaray_client)
# cmake-lint: disable=E1120
set_target_properties(gammaray_client PROPERTIES ${GAMMARAY_DEFAULT_LIBRARY_PROPERTIES})
gammaray_set_rpath(gammaray_client ${LIB_INSTALL_DIR})
target_compile_features(gammaray_client PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})

gammaray_target_relocatable_interfaces(gammaray_client_ipaths)
target_include_directories(
    gammaray_client
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}> $<INSTALL_INTERFACE:${gammaray_client_ipaths}>
)
target_link_libraries(
    gammaray_client
    PUBLIC Qt::Core
    PRIVATE gammaray_ui
            gammaray_ui_internal
            gammaray_common
            Qt::Gui
            Qt::Widgets
            Qt::Network
)
if(GAMMARAY_USE_PCH)
    target_precompile_headers(gammaray_client REUSE_FROM gammaray_pch_core_gui)
endif()

set(gammaray_client_srcs main.cpp)
gammaray_add_win_icon(gammaray_client_srcs)

add_executable(
    gammaray-client WIN32
    ${gammaray_client_srcs}
)

target_link_libraries(
    gammaray-client
    gammaray_client
    gammaray_common
    Qt::Gui
    Qt::Widgets
)

gammaray_embed_info_plist(gammaray-client ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in)
set_target_properties(
    gammaray-client PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIBEXEC_INSTALL_DIR}"
)
gammaray_set_rpath(gammaray-client ${LIBEXEC_INSTALL_DIR})

install(
    TARGETS gammaray_client
    EXPORT GammaRayTargets
    ${INSTALL_TARGETS_DEFAULT_ARGS}
)

gammaray_install_headers(
    ${CMAKE_CURRENT_BINARY_DIR}/gammaray_client_export.h clientconnectionmanager.h processtracker.h
)

ecm_generate_pri_file(
    BASE_NAME
    GammaRayClient
    LIB_NAME
    gammaray_client
    DEPS
    "core gui widgets network GammaRayCommon GammaRayUi"
    FILENAME_VAR
    PRI_FILENAME
    INCLUDE_INSTALL_DIR
    ${INCLUDE_INSTALL_DIR}
)

install(
    FILES ${PRI_FILENAME}
    DESTINATION ${ECM_MKSPECS_INSTALL_DIR}
)
if(MSVC)
    install(
        FILES "$<TARGET_PDB_FILE_DIR:gammaray_client>/$<TARGET_PDB_FILE_NAME:gammaray_client>"
        DESTINATION ${BIN_INSTALL_DIR}
        CONFIGURATIONS Debug RelWithDebInfo
    )
endif()

install(
    TARGETS gammaray-client
    DESTINATION ${LIBEXEC_INSTALL_DIR}
)

=== examples/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2016 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

add_subdirectory(quick-batching)
add_subdirectory(quick-event-handling)

if(${QT_VERSION_MAJOR} EQUAL 6 AND TARGET Qt6::StateMachine)
    add_subdirectory(state-machine)
endif()

if(TARGET Qt::Widgets)
    add_subdirectory(signal-slot)
    add_subdirectory(timer)
    add_subdirectory(widget-layouting)
endif()

if(Qt${QT_VERSION_MAJOR}3DExtras_FOUND)
    add_subdirectory(qt3d-geometry)
endif()

=== plugins/modelinspector/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2016 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# probe part
if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    set(gammaray_models_srcs
        modelinspector.cpp
        modelinspectorinterface.cpp
        modelmodel.cpp
        modelcellmodel.cpp
        modelcontentproxymodel.cpp
        selectionmodelmodel.cpp
        modelinspector.h
        modelinspectorinterface.h
        modelmodel.h
        modelcellmodel.h
        modelcontentproxymodel.h
        selectionmodelmodel.h
    )

    gammaray_add_plugin(
        gammaray_modelinspector
        JSON
        gammaray_modelinspector.json
        SOURCES
        ${gammaray_models_srcs}
    )
    set_target_properties(gammaray_modelinspector PROPERTIES DISABLE_PRECOMPILE_HEADERS ON)

    target_link_libraries(gammaray_modelinspector gammaray_core gammaray_kitemmodels)
endif()

# ui part
if(GAMMARAY_BUILD_UI)

    set(gammaray_models_ui_srcs
        modelcontentdelegate.cpp
        modelcontentdelegate.h
        modelinspectorclient.cpp
        modelinspectorclient.h
        modelinspectorinterface.cpp
        modelinspectorinterface.h
        modelinspectorwidget.cpp
        modelinspectorwidget.h
    )

    gammaray_add_plugin(
        gammaray_modelinspector_ui
        JSON
        gammaray_modelinspector.json
        SOURCES
        ${gammaray_models_ui_srcs}
    )

    target_link_libraries(gammaray_modelinspector_ui gammaray_ui)

endif()

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=gammaray
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.3.0
pkgrel=1
pkgdesc="A tool for examining the internals of a Qt application and to some extent also manipulate it (mingw-64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url="https://www.kdab.com/gammaray/"
msys2_repository_url="https://github.com/KDAB/GammaRay"
msys2_references=(
  'archlinux: gammaray'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-dlfcn"
         "${MINGW_PACKAGE_PREFIX}-syntax-highlighting")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-extra-cmake-modules"
             "${MINGW_PACKAGE_PREFIX}-qt6-3d"
             "${MINGW_PACKAGE_PREFIX}-qt6-connectivity"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-location"
             "${MINGW_PACKAGE_PREFIX}-qt6-positioning"
             "${MINGW_PACKAGE_PREFIX}-qt6-scxml"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-svg"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-glslang"
             "${MINGW_PACKAGE_PREFIX}-kcoreaddons")
optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-3d: 3D plugins"
            "${MINGW_PACKAGE_PREFIX}-qt6-declarative: Quick/Qml and positioning plugins"
            "${MINGW_PACKAGE_PREFIX}-qt6-scxml: state machine viewer plugin"
            "${MINGW_PACKAGE_PREFIX}-qt6-connectivity: bluetooth plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-positioning: positioning plugin"
            "${MINGW_PACKAGE_PREFIX}-qt6-svg: Widget Export actions plugin"
            "${MINGW_PACKAGE_PREFIX}-qt6-tools: Widget Export actions plugin"
            "${MINGW_PACKAGE_PREFIX}-kcoreaddons")
source=(${msys2_repository_url}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz
        003-win32-not-elf.patch
        004-files-layout.patch
        005-fix-dll-naming.patch)
sha256sums=('03fda338025d31b6a2794550f090d538996bbb6f4888eab3acb39db5a17127a8'
            'b13e2caa213d0b83a37c72e57bb5dc6e1d7e3d06d3f3031ad8931df3059cd9c0'
            '5c7e44e3fa6e914e369c2149fe9ca4b9e133f6753c7c6539cef66c9aeac5da21'
            '1d4ebacca418f8f1c9df0c4c438742e63d5d372d37d1605ecf9b478b098155eb')
validpgpkeys=(E86C000370B1B9E2A9191AD53DBFB6882C9358FB) # KDAB Products <info@kdab.com>

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${_realname}-${pkgver}
  apply_patch_with_msg \
    003-win32-not-elf.patch \
    004-files-layout.patch \
    005-fix-dll-naming.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    _extra_config+=("-DSTACK_DETAILS_BFD=ON")
  else
    _extra_config+=("-DSTACK_DETAILS_BFD=OFF")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;-DECM_MKSPECS_INSTALL_DIR=;-DPLUGIN_INSTALL_DIR=;" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_INSTALL_OLDINCLUDEDIR=${MINGW_PREFIX}/include/qt6 \
    -DTRANSLATION_INSTALL_DIR=${MINGW_PREFIX}/share/qt6/translations \
    -DPLUGIN_INSTALL_DIR=${MINGW_PREFIX}/share/qt6/plugins/gammaray \
    -DECM_MKSPECS_INSTALL_DIR=${MINGW_PREFIX}/share/qt6/mkspecs/modules \
    -DGAMMARAY_INSTALL_QT_LAYOUT=ON \
    -DGAMMARAY_MULTI_BUILD=FALSE \
    -DGAMMARAY_WITH_KDSME=OFF \
    -DSTACK_DETAILS_AUTO_DETECT=OFF \
    -DMINGW_MSVCR_LIBRARY="" \
    -DQT_VERSION_MAJOR=6 \
    "${_extra_config[@]}" \
    -S ${_realname}-${pkgver} \
    -B build-${MSYSTEM}

  ${MINGW_PREFIX}/bin/cmake.exe --build build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install build-${MSYSTEM}

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
